var app = require('express')();
var http = require('http').createServer(app);
var io = require('socket.io')(http);
var fs = require('fs');
var util = require('util');
var configReader=require("./classes/configRead.class");
var linkUrl={
	"app":"b2bstore.panamahatters.store",
	"cdn":"b2bstore.panamahatters.store",
	"storage":"v-storage.it"
};

var log_file = fs.createWriteStream(__dirname + '/debug.log', {flags : 'a'});
var log_stdout = process.stdout;
//OVERRIDE CONSOLE.LOG
console.log=function(d){
	log_file.write(util.format(d) + '\n');
	log_stdout.write(util.format(d) + '\n');
};

var processIndex=function(configurations){
	var result="";
	var list=configurations;
	this.setList=function(lista,cb){
		list=lista;
		cb();
	}
	var createSingle=function(block,string,cb){
		switch(block){
			case 'moduliGui':
				cb(`<script src="https://${linkUrl.cdn}/js/classes/${string}.class.js"></script>`);
			break;
			case 'pages':
				cb(`<script src="https://${linkUrl.cdn}/js/classes/pages/${string}.class.js"></script>`);
			break;
		}
	}
	this.process=function(cb){
		var result="";
		var total=Object.keys(list.moduliGui).length+Object.keys(list.pages).length;
		var count=0;
		for(var i in list.moduliGui){
			// {"id":"id"}
			createSingle('moduliGui',i,function(data){
				result+=data;
				count++;
				if(total==count){
					cb(result);
				}
			});
		}
		for(var o in list.pages){
			// {"id":"id"}
			createSingle('pages',o,function(data){
				result+=data;
				count++;
				if(total==count){
					cb(result);
				}
			});
		}
	}
}

http.listen(3000, function(){
	var cReader=new configReader.initiate();
	cReader.read(
		{
			'db':'db',
			'moduli':'moduli',
			'moduliGui':'moduliGui',
			'pages':'pages'
		},function(configurations){
			fs.readFile(__dirname +"/models/index.mod", 'utf8', function (err,model) {
				if (err) {
					return console.log(err);
				}
				var index_html=fs.createWriteStream(__dirname + '/html/index.html', {flags : 'w'});
				var modIndex=new processIndex(configurations);
				modIndex.process(function(m){
					model=model.replace(/\[CDNLINK\]/g,linkUrl.cdn);
					model=model.replace("[DYNAMIC]",m);
					index_html.write(model);
					var main = require('./classes/main.class');
					var execute=new main.Main(io,configurations);
				});
			});
		}
	);
});


app.get('/', function (req, res) {
	res.sendFile(__dirname + '/html/');
});
