var fs = require('fs');

/*
var configRead=function(){
	var self=this;
	var readSingle=function(tag,file,cb){
		fs.readFile(__dirname +"/../config/"+file+".json", 'utf8', function (err,data) {
			if (err) {
				return console.log(err);	
			}
			cb(tag,JSON.parse(data));
		});
	}
	this.read=function(listFile,cb){
		var ritorno={};
		var total=Object.keys(listFile).length;
		var count=0;
		for(var i in listFile){
			// {"id":"id"}
			readSingle(i,listFile[i],function(tag,data){
				ritorno[tag]=data;
				count++;
				if(total==count){
					cb(ritorno);
				}
			});
		}
	}	
}
*/

var configRead=function(){
	var self=this;
	var readSingle = (tag, file) => {
		return new Promise(function(resolve, reject){
			fs.readFile(__dirname +"/../config/"+file+".json", 'utf8', (err,data) => {
				err ? reject(err) : resolve({"tag":tag, "data":JSON.parse(data)});
			});
		});
	}
	this.read = (listFile,cb) => {
		var retval = {};
		var promises = [];
		for(var i in listFile) {
			promises.push(readSingle(i, listFile[i]).then(item => {
			    retval[item.tag] = item.data;
			}));
		}
		Promise.all(promises).then(function() {
		    cb(retval);
		})
		.catch(err => {
            console.log(err);
		});
	}
}

module.exports={
	initiate:configRead
};