var dataManager=function(moduli){
	var self=this;
	var db=moduli.db;
	var conn=db.get("system");

	var queryAsync = ((label, query) => { 
		return new Promise((resolve, reject) => {
			if(query.length === 0) return resolve({"label":label, "result": []});
			conn.query(query, (err, result) => {
				if(err) return reject(err);
				resolve({"label":label, "result": result});  
			});
		});
	});
	
	this.get=function(query_this,cb){
		conn.query(query_this,function(err,result){
			if(err) {
				cb(false,err);
			} else {
				cb(true,result);
			}
		});
	}

	this.getAll=function(queries, cb) {
		var results = {};
		var promises = [];
		for(var i in queries) {
			promises.push(queryAsync(i, queries[i]).then(dict => {
				results[dict.label] = dict.result;
			}));
		}
		Promise.all(promises)
		.then(function(){
			cb(true, results);
		})
		.catch(function(err) {
			console.log('Error getAll: '+err);
			cb(false, err);
		});
	}

	this.execCmd = (sqlCmdList, cb) => {
		var results = {};
		var promises = [];
		for(let outerIndex=0;  outerIndex<sqlCmdList.length; outerIndex++) {
			for(var i in sqlCmdList[outerIndex]) {
				promises.push(queryAsync(i+"_"+outerIndex, sqlCmdList[outerIndex][i]).then(dict => {
					results[dict.label] = dict.result.affectedRows;
				}));
			}
		}
		Promise.all(promises)
		.then(function(){
			let total = 0;
			for(let x in results) total += results[x];
			cb(true, total);
		})
		.catch(function(err) {
			console.log('Error execCmd: '+err);
			cb(false, err);
		});
	}
	
	this.listener=function(io,socket){
		
	}
}

module.exports={
	initiate:dataManager
};