var numb2price=function(num,simbolo){
	var numb=parseFloat(num);	
	var ritorno=number_format(numb,2,',',' ');
	return ritorno+'&nbsp;'+simbolo;
}

function number_format(numero, decimali, dec_separatore, mig_separatore){
	// Elimino i caratteri che non sono numeri (lascio il segno meno e il punto)
	numero=(''+numero).replace(/[^0-9\.\-]?/gi,"");
	// Controllo se valore numerico
	var n = 0;
	if(isFinite(+numero)){
		n=numero;
	}
	// Controllo se i decimali sono accettabili
	var precisione = 0;
	if(isFinite(+decimali) && decimali>-1){
		precisione = decimali;
	}
	// Recupero caratteri separatori
	var separatore = '.';
	if(typeof mig_separatore != 'undefined'){
		separatore = mig_separatore;
	}
	var dec = ',';
	if(typeof dec_separatore != 'undefined'){
		var dec = dec_separatore;     
	}
	// Arrotondo il valore se necessario - Utilizzo funzione toFixedFix
	var s = '';
	if(precisione!=0){
		s = toFixedFix(n, precisione);    
	}else{
		s = '' + Math.round(n);
	}
	// Taglio il valore in parte intera e parte decimale
	s = s.split('.');
	// Aggiungo il separatore delle migliaia - ogni 3 numeri sulla parte intera
	if (s[0].length > 3) {        
		s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, separatore);
	}
	// Formatto la parte decimale - aggiungo degli 0 se necessari
	if ((s[1] || '').length < precisione) {
		s[1] = s[1] || '';
		s[1] += new Array(precisione - s[1].length + 1).join('0');    
	}
	// Aggiungo parte decimale a parte intera - separati da separatore decimali
	return s.join(dec);
}

function toFixedFix(n, precisione) {
	// Funzione per arrotondare valore
	var k = Math.pow(10, precisione);            
	return '' + Math.round(n * k) / k;
}

	
var cart=function(){
	var self=this;
	var data={"variabili":{},"tabelle":{},"filters":{}};
	var activeListener=false;
	
	// Metodo obbligatorio
	this.setListener=function(status_l){
		activeListener=status_l;
	}
	
	// Metodo obbligatorio
	this.listener=function(io,socket){
		//QUI SI INSERISCONO GLI ASCOLTATORI DEDICATI ALLA PAGINA
		socket.on('example', function(data){
			if(activeListener){
				// IN OGNI ASCOLTATORE SERVE IL CONTROLLO SU activeListener
				console.log(data);				
			}
		});
	}
	
	//getQuery Metodo obbligatorio che trasmette le query per ottenere i dati utili per questa pagina
	this.getQuery=function(data){
		return{
			"cart_items":
				"SELECT `id`, `id-buyer`, `id-brand`, `nome_brand`, `id-collezione`,"
				+" `nome_collezione`, `ordine_collezione`, `scala_taglie`, `id_articolo`,"
				+" `codice_articolo`, `id-cartella_colore`, `prezzo_unitario`, `link_foto_principale`,"
				+" `codice_colore`, `nome_colore`, `link_immagine_campione_colore`, `taglia`,"
				+" `quantita`, `prezzo_unitario_riservato`, `totale_costo_articolo`, `valuta`,"
				+" `simbolo_valuta`, `fabric`, `id-colore`, `taglie_det`"
				+" FROM `cart-items_carrello`"
				+" WHERE `id-buyer` = \""+data.id_user+"\""
				+" ORDER BY `ordine_collezione`, `id_articolo`;"
			/*	
			,"colors_by_article":
				"SELECT `id_buyer`, `id_articolo`, `id_colore`, `codice_colore`, `nome_colore`, `link_immagine_campione_colore`"
				+" FROM `cart_colors_by_article`"
				+" WHERE `id_buyer` = \""+data.id_user+"\";"
			*/
		};
	}

	//getQuery Metodo che trasmette le query per ottenere i dati utili per questa pagina
	this.get=function(dataset,filters,cb){
		data.tabelle=dataset;
		data.filters=filters;
		data.variabili={};

		let collections={"keySorted":[]};

		var groupByColor=(list) => {
			let result={};
			
		
			
			for(let item of list){
			    let id_colore=item["id-colore"];
				let codice_colore=item["codice_colore"];
				let nome_colore=item["nome_colore"];
				let link_immagine_campione_colore=item["link_immagine_campione_colore"];
				let taglia=item["taglia"];
				let qty=item["quantita"];
				let prezzo=item["prezzo_unitario_riservato"];

				if(!(codice_colore in result)) {
				    let scala_taglie=item["scala_taglie"];
				    let ids=item["taglie_det"];
				    let st=scala_taglie.split(',');
				    let idsArr=ids.split(',');
			        let taglie={};
			        let i=0;
				    for(let k of st){
					    taglie[k]={ "id_colore":id_colore, "prezzo":prezzo, "id_taglia":idsArr[i], "qty":0 };
					    i++;
				    }
					result[codice_colore]={
						"id_colore":id_colore,
						"nome_colore":nome_colore,
						"link_immagine_campione_colore":link_immagine_campione_colore,
						"tot_qty":0,
						"tot_price":0,
						"tg_qty":0,
						"taglie":taglie,
					}
				}
				result[codice_colore].taglie[taglia].qty=qty
				result[codice_colore].tot_qty+=qty;
			}
			return result;
		}

		function keyCompare( a, b ) {
			if ( a.val < b.val ){
			  return 1;
			}
			if ( a.val > b.val ){
			  return -1;
			}
			return 0;
	    }
		
		var simbolo_valuta="";
        const sum = (accumulator, currentValue) => accumulator + currentValue;
		if(data.tabelle.cart_items.length > 0) {
			for(let item of data.tabelle.cart_items) {
				let id_collezione=item["id-collezione"];
				let nome_collezione=item["nome_collezione"];
				let nome_brand=item["nome_brand"];
				let key=id_collezione+"_"+nome_collezione;
				let codice=item["codice_articolo"];

				let id_articolo=item["id_articolo"];
				let codice_articolo=item["codice_articolo"];
				let prezzo_unitario=item["prezzo_unitario_riservato"];
				let link_foto_principale=item["link_foto_principale"];
				let fabric=item["fabric"];

				if(!(key in collections)) {
					simbolo_valuta=item["simbolo_valuta"];
					collections.keySorted.push(key);
					collections[key]= {
						"nome_brand":nome_brand, 
						"id-collezione":id_collezione,
						"nome_collezione":item["nome_collezione"],
						"valuta":item["valuta"],
						"simbolo_valuta":item["simbolo_valuta"],
						"tot_qty":0,
						"tot_price":0,
						"articoli":{"keySorted":[]}
					};
				}
				if(!(codice in collections[key].articoli)) {
					collections[key].articoli.keySorted.push(codice);
					collections[key].articoli[codice]={
						"id_collezione":id_collezione,
						"id_articolo":id_articolo,
						"codice_articolo":codice_articolo,
						"prezzo_unitario":prezzo_unitario,
						"link_foto_principale":link_foto_principale,
						"fabric":fabric,
						"tot_qty":0,
						"tot_price":0,
						"colors_tmp":[],
						"colors":{}
					};
				}
				collections[key].articoli[codice].colors_tmp.push(item);
			}
			
			for(let i of collections.keySorted) {
				for(let j of collections[i].articoli.keySorted) {
					let arr = collections[i].articoli[j].colors_tmp;
					let id_articolo=collections[i].articoli[j].id_articolo;
					let prezzo=collections[i].articoli[j].prezzo_unitario;
					let grouped=groupByColor(arr);
					/*
					let scale=grouped[Object.keys(grouped)[0]].taglie;
					for(let col of data.tabelle.colors_by_article.filter(clr => clr.id_articolo == id_articolo)){
						if(!(col.codice_colore in grouped)) {
							let taglie={};
							for(let i in scale){
								taglie[i]={ "id_colore":col.id_colore, "prezzo":prezzo, "id_taglia":scale[i].id_taglia, "qty":0 };
							}
							let voidColor={
								"nome_colore":col.nome_colore,
								"link_immagine_campione_colore":col.link_immagine_campione_colore,
								"tot_qty":0,
								"tot_price":0,
								"tg_qty":0,
								"taglie":taglie,
							};
							grouped[col.codice_colore]=voidColor;
						}
					}
					*/
					collections[i].articoli[j].colors_tmp=[];
					let keySorted=[];
					for(let u in grouped) {
						keySorted.push({"key":u, "val":grouped[u].tot_qty});
					}
					keySorted=keySorted.sort(keyCompare);
					keySorted=keySorted.map(x => x.key);
					grouped.keySorted=keySorted
					collections[i].articoli[j].colors=grouped;
				}
			}
			
			data.tabelle={};
			data.tabelle.collections = [];
			for(let collection of collections.keySorted){
				let articlesArr=[];
				for(let article of collections[collection].articoli.keySorted) {
					let colorsArr=[];
					for(let color of collections[collection].articoli[article].colors.keySorted){
						let taglieArr=[];
						let nome_colore = collections[collection].articoli[article].colors[color].nome_colore;
						let taglieObj = collections[collection].articoli[article].colors[color].taglie;
						let tot_tg = Object.keys(taglieObj).length;
						for(let tg in taglieObj){
							let id_collezione=collections[collection].articoli[article].id_collezione;
							let id_articolo=collections[collection].articoli[article].id_articolo;
							let quantita=taglieObj[tg].qty;
							let id_colore=taglieObj[tg].id_colore;
							let prezzo=taglieObj[tg].prezzo;
							let id_taglia=taglieObj[tg].id_taglia;
							taglieArr.push({
								"id_taglia":id_taglia,
								"taglia":tg, 
								"qty":quantita, 
								"tg_qty":tot_tg, 
								"id_collezione":id_collezione, 
								"id_articolo":id_articolo, 
								"id_colore":id_colore,
								"nome_colore":nome_colore,
								"prezzo":prezzo
							});
						}
						collections[collection].articoli[article].colors[color].tg_qty=taglieArr.length;
						collections[collection].articoli[article].colors[color].tot_price=collections[collection].articoli[article].colors[color].tot_qty * collections[collection].articoli[article].prezzo_unitario; 
						collections[collection].articoli[article].colors[color].taglie=JSON.stringify(taglieArr);
						let colorObj=collections[collection].articoli[article].colors[color];
						colorsArr.push(colorObj);
					}
					collections[collection].articoli[article].tot_qty=colorsArr.map(x => x.tot_qty).reduce(sum);
					collections[collection].articoli[article].tot_price=colorsArr.map(x => x.tot_price).reduce(sum); 
					collections[collection].articoli[article].colors=JSON.stringify(colorsArr);
					let articleObj=collections[collection].articoli[article];
					articlesArr.push(articleObj);
				}
				collections[collection].tot_qty=articlesArr.map(x => x.tot_qty).reduce(sum);
				collections[collection].tot_price=numb2price(articlesArr.map(x => x.tot_price).reduce(sum),simbolo_valuta); 
				collections[collection].articoli=JSON.stringify(articlesArr);
				let collectionObj=collections[collection];
				data.tabelle.collections.push(collectionObj);
			}
			data.variabili.tot_qty=data.tabelle.collections.map(x => x.tot_qty).reduce(sum);
			data.variabili.tot_price=data.tabelle.collections.map(x => x.tot_price).reduce(sum);
		} else {
            data.variabili.tot_qty=0;
            data.variabili.tot_price=numb2price(0,simbolo_valuta);
            data.tabelle.collections=[];
        }
		cb(data);
	}
}

module.exports={
	initiate:cart
};