var collection = function () {
  var self = this;
  var data = { variabili: {}, tabelle: {}, filters: {} };
  var activeListener = false;
  this.setListener = function (status_l) {
    activeListener = status_l;
  };
  this.listener = function (io, socket) {
    socket.on("example", function (data) {
      if (activeListener) {
        console.log(data);
      }
    });
  };

  this.dynamicQuery = [
    {
      label: "save_name_cart",
      dbase: "system",
      composer: function (data, cb) {
        cb(
          `INSERT INTO \`carrelli_salvati\`( \`nome\`, \`id-buyer\`) VALUES ('${data.name}','${data.id_buyer}')`
        );
      },
    },
    {
      label: "save_details_cart",
      dbase: "system",
      composer: function (data, cb) {
        var query = data.join(",");
        var sql = `INSERT INTO \`carrelli_salvati_details\`( \`id-cart\`, \`id-articolo\`, \`taglia\`, \`id-taglia\`, \`id-colore\`, \`quantita\`, \`prezzo\`) VALUES ${query}`;
        console.log(query);
        cb(sql);
      },
    },
    {
      label: "delete_details_saved_cart",
      dbase: "system",
      composer: function (data, cb) {
        var sql = `DELETE FROM \`carrelli_salvati_details\` WHERE \`id-cart\`=${data.id_cart}`;
        cb(sql);
      },
    },
    {
      label: "get_article_details",
      dbase: "system",
      composer: function (data, cb) {
        cb(
          "SELECT * FROM `articolo_dettaglio_new` AS a JOIN `home_buyer-immagini_articolo` AS i ON a.`id-articolo`=i.`id-articolo` WHERE a.`id-articolo`='" +
            data.id_article +
            "' AND a.`id-buyer`='" +
            data.id_buyer +
            "'"
        );
      },
    },
    {
      label: "get_article_details_2",
      dbase: "system",
      composer: function (data, cb) {
        cb(
          "SELECT * FROM `home_buyer-dettagli_articolo` WHERE `id-articolo`='" +
            data.id_article +
            "'"
        );
      },
    },
    {
      label: "insert_cart",
      dbase: "system",
      composer: function (data, cb) {
        var query = `INSERT INTO carrello(\`id-buyer\`, \`id_carrello\`, \`id-articolo\`, \`id-taglia\`, quantita, prezzo_unitario_riservato) VALUES ('${data.id_buyer}','${data.id_cart}','${data.id_articolo}','${data.id_taglia}','${data.qt}','${data.prezzo}') ON DUPLICATE KEY UPDATE quantita='${data.qt}', prezzo_unitario_riservato='${data.prezzo}'`;
        cb(query);
      },
    },
    {
      label: "delete_cart",
      dbase: "system",
      composer: function (data, cb) {
        var query = `DELETE FROM carrello WHERE \`id-buyer\`='${data.id_buyer}'  AND id_carrello<>'0'`;
        cb(query);
      },
    },
    {
      label: "read_cart",
      dbase: "system",
      composer: function (data, cb) {
        var query = `SELECT * FROM carrelli_salvati_details WHERE \`id-cart\`='${data.id_cart}'`;
        cb(query);
      },
    },
    {
      label: "update_cart",
      dbase: "system",
      composer: function (data, cb) {
        var query = `INSERT INTO carrello(\`id-buyer\`,\`id_carrello\`, \`id-articolo\`, \`id-colore\`, \`id-taglia\`, \`quantita\`, \`prezzo_unitario_riservato\`) 
							SELECT ${data.id_buyer},${data.id_cart},\`id-articolo\`, \`id-colore\`, \`id-taglia\`, \`quantita\`, \`prezzo\` FROM carrelli_salvati_details WHERE \`id-cart\`=${data.id_cart} AND quantita>0`;
        console.log(query);
        cb(query);
      },
    },
    {
      label: "add_favourite",
      dbase: "system",
      composer: function (data, cb) {
        var query = `INSERT INTO \`preferiti\`(\`id-buyer\`, \`id-articolo\`) VALUES (${data.id_buyer},${data.id_article})`;
        cb(query);
      },
    },
    {
      label: "remove_favourite",
      dbase: "system",
      composer: function (data, cb) {
        var query = `DELETE FROM \`preferiti\` WHERE \`id-buyer\`=${data.id_buyer} AND \`id-articolo\`=${data.id_article}`;
        cb(query);
      },
    },
    {
      label: "get_images",
      dbase: "system",
      composer: function (data, cb) {
        var query = `SELECT * FROM \`home_buyer-immagini_articolo\` WHERE \`id-articolo\`='${data.id_article}' ORDER BY ordine`;
        cb(query);
      },
    },
    {
      label: "update_cart_flag",
      dbase: "system",
      composer: function (data, cb) {
        var query = `UPDATE carrello SET al_pronto='${data.flag}' WHERE id_carrello='${data.id_cart}'`;
        cb(query);
      },
    },
  ];

  this.getQuery = function (data) {
    return {
      "home_buyer-singola_collezione_articolo":
        'SELECT a.`id-articolo`, a.`nome-articolo`,a.`testo`,a.`type`,a.`line`, a.`ordine`,a.`id_scala_taglie`,a.`scala_taglie`, a.`immagine-articolo`, a.`prezzo`, a.`simbolo_valuta`,IF(p.`id-articolo`>0, 1, 0) AS pref FROM `home_buyer-singola_collezione_articoli` AS a LEFT JOIN `home_buyer-preferiti_articolo` AS p ON a.`id-articolo`=p.`id-articolo` AND a.`id-buyer`=p.`id-buyer` WHERE a.`id-buyer`="' +
        data.id_user +
        '" AND a.`id-collezione`=1 AND a.`id-articolo` NOT IN (SELECT `id-articolo` FROM `articoli_esclusi` WHERE `id-buyer_collezioni`=(SELECT id FROM buyer_collezioni WHERE `id-buyer`=' +
        data.id_user +
        " AND `id-collezione`=1)) ORDER BY a.`ordine`",
      "home_buyer-carrelli_salvati":
        'SELECT id,nome FROM `carrelli_salvati` WHERE `id-buyer`="' +
        data.id_user +
        '";',
      "home_buyer-filtri_collezione":
        'SELECT `id`, `id-collezione`, `label`, `categoria`, `attivo` FROM `home_buyer-filtri_collezione` WHERE `id-collezione` ="1" ORDER BY label;',
      "home_buyer-filtri_articolo":
        'SELECT * FROM `home_buyer-categoria_articolo` WHERE `id-collezione` ="1" ORDER BY `id-articolo`;',
      "home_buyer-carrello":
        'SELECT * FROM `cart-items_carrello` WHERE `id-buyer`="' +
        data.id_user +
        '" AND `id-collezione`=1;',
      "home_buyer-minimi":
        'SELECT * FROM `limiti_acquisto` WHERE `id-buyer`="' +
        data.id_user +
        "\" AND attivo='1';",
      "home_buyer-taglie": "SELECT * FROM `home_buyer-taglie` ;",
      "home_buyer-magazzini":
        "SELECT * FROM b2bstorepanama_magazzino.articoli WHERE attivo='1';",
      // ,"home_buyer-categoria_articolo":"SELECT COALESCE(GROUP_CONCAT(DISTINCT `cat`.`categoria` ORDER BY  `cat`.`categoria` ASC SEPARATOR ','),'Articoli') AS `categorie`, `art`.`id-collezione`, `art`.`id-articolo`, `art`.`nome-articolo`, GROUP_CONCAT(DISTINCT `art`.`immagine-articolo` ORDER BY  `art`.`id-articolo` ASC SEPARATOR ';') AS `immagine-articolo`, MIN(`art`.`prezzo`) AS `prezzo`, MIN(`art`.`simbolo_valuta`) AS `simbolo_valuta`, CASE WHEN COALESCE(`pref`.`id-articolo`, 0) = 0 THEN 0 ELSE 1 END AS `preferito` FROM `home_buyer-singola_collezione_articoli` AS `art` LEFT OUTER JOIN `home_buyer-categoria_articolo` AS `cat` ON `art`.`id-articolo` = `cat`.`id-articolo` LEFT OUTER JOIN `home_buyer-preferiti_articolo` AS `pref` ON `pref`.`id-articolo` = `art`.`id-articolo` WHERE `art`.`id-buyer` = \""+data.id_user+"\" AND `art`.`id-collezione` = \""+data.ids[0]+"\" AND (`pref`.`id-buyer` IS NULL OR `pref`.`id-buyer` = \""+data.id_user+"\") GROUP BY `art`.`id-articolo` ORDER BY `art`.`ordine`;"
      // ,"home_buyer-preferiti_articolo":"SELECT `id-buyer`, `id-collezione`, `id-articolo` FROM `home_buyer-preferiti_articolo` WHERE `id-collezione` =\""+data.ids[0]+"\";"
    };
  };

  var popola_filtri = function (s, cb) {
    var rit = [];
    for (var i in s) {
      rit.push(s[i]);
    }
    cb(rit);
  };

  this.get = function (dataset, filters, cb_get) {
    data.tabelle = dataset;
    data.variabili = {};
    var filter_table = data.tabelle["home_buyer-filtri_collezione"];
    var selects = {};
    var old_label = "";
    for (var i in filter_table) {
      if (old_label != filter_table[i].label) {
        if (selects[old_label] != undefined) {
          selects[old_label].select += `</select>`;
        }
        old_label = filter_table[i].label;
      }
      if (selects[filter_table[i].label] == undefined) {
        selects[filter_table[i].label] = { select: "" };
        selects[
          filter_table[i].label
        ].select = `<select class="filter filter_${filter_table[i].label} btn-primary" data-cat="${filter_table[i].label}"><option value="-1" style="display:none;">${filter_table[i].label}</option><option value="0">All</option>`;
      }
      selects[
        filter_table[i].label
      ].select += `<option value="${filter_table[i].categoria}">${filter_table[i].categoria}</option>`;
    }
    selects[old_label].select += `</select>`;
    popola_filtri(selects, function (r) {
      data.tabelle.new_filter = r;
      cb_get(data);
    });
  };
};

module.exports = {
  initiate: collection,
};
